'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.IconButton = exports.MiniFabButton = exports.FabButton = exports.RaisedButton = exports.FlatButton = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var getClasses = function getClasses(props) {
    return {
        'mdl-button': true,
        'mdl-button--raised': props.type == 'raised',
        'mdl-button--fab': props.type == 'fab' || props.type == 'miniFab',
        'mdl-button--mini-fab': props.type == 'miniFab',
        'mdl-button--icon': props.type == 'icon',
        'mdl-button--colored': props.colored,
        'mdl-button--primary': props.primary,
        'mdl-button--accent': props.accent
    };
};

var Button = function Button(props) {
    var disabled = props.disabled;
    var primary = props.primary;
    var colored = props.colored;
    var accent = props.accent;

    var otherProps = _objectWithoutProperties(props, ['disabled', 'primary', 'colored', 'accent']);

    return _react2["default"].createElement(
        'button',
        _extends({ className: (0, _classnames2["default"])(getClasses(props)), disabled: disabled }, otherProps),
        props.children
    );
};

Button.propTypes = {
    type: _react2["default"].PropTypes.oneOf(['flat', 'raised', 'fab', 'miniFab', 'icon']).isRequired,
    colored: _react2["default"].PropTypes.bool,
    primary: _react2["default"].PropTypes.bool,
    accent: _react2["default"].PropTypes.bool,
    disabled: _react2["default"].PropTypes.bool
};

Button.defaultProps = {
    disabled: false
};

Button.displayName = 'Button';

var _Button$propTypes = Button.propTypes;
var type = _Button$propTypes.type;

var typedButtonPropTypes = _objectWithoutProperties(_Button$propTypes, ['type']);

var FlatButton = exports.FlatButton = function FlatButton(props) {

    props = _extends({}, props, {
        type: 'flat'
    });

    return _react2["default"].createElement(Button, props);
};

FlatButton.propTypes = _extends({}, typedButtonPropTypes);

FlatButton.defaultProps = _extends({}, Button.defaultProps);

FlatButton.displayName = 'FlatButton';

var RaisedButton = exports.RaisedButton = function RaisedButton(props) {

    props = _extends({}, props, {
        type: 'raised'
    });

    return _react2["default"].createElement(Button, props);
};

RaisedButton.propTypes = _extends({}, typedButtonPropTypes);

RaisedButton.defaultProps = _extends({}, Button.defaultProps);

RaisedButton.displayName = 'RaisedButton';

var FabButton = exports.FabButton = function FabButton(props) {

    props = _extends({}, props, {
        type: 'fab'
    });

    return _react2["default"].createElement(Button, props);
};

FabButton.propTypes = _extends({}, typedButtonPropTypes);

FabButton.defaultProps = _extends({}, Button.defaultProps);

FabButton.displayName = 'FabButton';

var MiniFabButton = exports.MiniFabButton = function MiniFabButton(props) {

    props = _extends({}, props, {
        type: 'miniFab'
    });

    return _react2["default"].createElement(Button, props);
};

MiniFabButton.propTypes = _extends({}, typedButtonPropTypes);

MiniFabButton.defaultProps = _extends({}, Button.defaultProps);

MiniFabButton.displayName = 'MiniFabButton';

var IconButton = exports.IconButton = function IconButton(props) {

    props = _extends({}, props, {
        type: 'icon'
    });

    return _react2["default"].createElement(Button, props);
};

IconButton.propTypes = _extends({}, typedButtonPropTypes);

IconButton.defaultProps = _extends({}, Button.defaultProps);

IconButton.displayName = 'IconButton';