'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Card = exports.CardMenu = exports.CardActions = exports.CardText = exports.CardMedia = exports.CardTitle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getCardClasses = function getCardClasses(depth) {
    var classes = {
        'mdl-card': true
    };
    if (depth) {
        classes = _extends({}, classes, _defineProperty({}, 'mdl-shadow--' + depth + 'dp', true));
    }
    return classes;
};

var CardTitle = exports.CardTitle = function CardTitle(props) {
    var importance = props.importance;
    var textTitle = props.textTitle;
    var style = props.style;
    var children = props.children;
    var className = props.className;

    var otherProps = _objectWithoutProperties(props, ['importance', 'textTitle', 'style', 'children', 'className']);

    var title = _react2["default"].createElement('h' + importance, _extends({}, otherProps, {
        className: (0, _classnames2["default"])({
            'mdl-card__title-text': textTitle
        })
    }), children);

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-card__title', style: style }, otherProps),
        title
    );
};

CardTitle.propTypes = {
    importance: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6]),
    textTitle: _react2["default"].PropTypes.bool
};

CardTitle.defaultProps = {
    importance: 2,
    textTitle: true
};

var CardMedia = exports.CardMedia = function CardMedia(props) {

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-card__media' }, props),
        props.children
    );
};

var CardText = exports.CardText = function CardText(props) {

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-card__supporting-text' }, props),
        props.children
    );
};

var CardActions = exports.CardActions = function CardActions(props) {

    var className = (0, _classnames2["default"])({
        'mdl-card__actions': true,
        'mdl-card--border': props.border
    });

    return _react2["default"].createElement(
        'div',
        _extends({ className: className }, props),
        props.children
    );
};

CardActions.propTypes = {
    border: _react2["default"].PropTypes.bool
};

CardActions.defaultProps = {
    border: true
};

var CardMenu = exports.CardMenu = function CardMenu(props) {

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-card__menu' }, props),
        props.children
    );
};

var Card = exports.Card = function Card(props) {
    var depth = props.depth;

    var otherProps = _objectWithoutProperties(props, ['depth']);

    var className = (0, _classnames2["default"])(_extends({}, otherProps.className, getCardClasses(depth)));

    return _react2["default"].createElement(
        'div',
        _extends({ className: className }, otherProps),
        props.children
    );
};

Card.propTypes = {
    depth: _react2["default"].PropTypes.oneOf([2, 3, 4, 6, 8, 16])
};