'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withHandlers = require('recompose/withHandlers');

var _withHandlers2 = _interopRequireDefault(_withHandlers);

var _lifecycle = require('recompose/lifecycle');

var _lifecycle2 = _interopRequireDefault(_lifecycle);

var _withState = require('recompose/withState');

var _withState2 = _interopRequireDefault(_withState);

var _mapProps = require('recompose/mapProps');

var _mapProps2 = _interopRequireDefault(_mapProps);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Constant_ = {
    TINY_TIMEOUT: 0.001
};

var CssClasses_ = {
    INPUT: 'mdl-checkbox__input',
    BOX_OUTLINE: 'mdl-checkbox__box-outline',
    FOCUS_HELPER: 'mdl-checkbox__focus-helper',
    TICK_OUTLINE: 'mdl-checkbox__tick-outline',
    IS_FOCUSED: 'is-focused',
    IS_DISABLED: 'is-disabled',
    IS_CHECKED: 'is-checked',
    IS_UPGRADED: 'is-upgraded'
};

var Checkbox = function Checkbox(_ref) {
    var _cx;

    var id = _ref.id;
    var checked = _ref.checked;
    var focus = _ref.focus;
    var disabled = _ref.disabled;
    var label = _ref.label;
    var onChange = _ref.onChange;
    var onFocus = _ref.onFocus;
    var _onBlur2 = _ref.onBlur;
    var _onMouseUp2 = _ref.onMouseUp;

    var otherProps = _objectWithoutProperties(_ref, ['id', 'checked', 'focus', 'disabled', 'label', 'onChange', 'onFocus', 'onBlur', 'onMouseUp']);

    var labelClassName = (0, _classnames2["default"])((_cx = {
        'mdl-checkbox': true,
        'mdl-js-checkbox': true
    }, _defineProperty(_cx, CssClasses_.IS_UPGRADED, true), _defineProperty(_cx, CssClasses_.IS_DISABLED, disabled), _defineProperty(_cx, CssClasses_.IS_CHECKED, checked), _defineProperty(_cx, CssClasses_.IS_FOCUSED, focus), _cx));
    var inputClassName = (0, _classnames2["default"])(_defineProperty({}, CssClasses_.INPUT, true));

    var input_ = undefined;

    return _react2["default"].createElement(
        'label',
        {
            htmlFor: id,
            className: labelClassName,
            onMouseUp: function onMouseUp(e) {
                return _onMouseUp2(e, input_);
            } },
        _react2["default"].createElement('input', _extends({
            type: 'checkbox',
            id: id,
            ref: function ref(_ref2) {
                return input_ = _ref2;
            },
            onChange: onChange,
            onFocus: onFocus,
            onBlur: function onBlur(e) {
                return _onBlur2(e, input_);
            },
            className: inputClassName,
            checked: checked
        }, otherProps)),
        label && _react2["default"].createElement(
            'span',
            { className: 'mdl-checkbox__label' },
            label
        ),
        _react2["default"].createElement('span', { className: CssClasses_.FOCUS_HELPER }),
        _react2["default"].createElement(
            'span',
            { className: CssClasses_.BOX_OUTLINE },
            _react2["default"].createElement('span', { className: CssClasses_.TICK_OUTLINE })
        )
    );
};

var enhance = function enhance(CheckboxComponent) {
    return function (_React$Component) {
        _inherits(CheckboxContainer, _React$Component);

        function CheckboxContainer(props) {
            _classCallCheck(this, CheckboxContainer);

            var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(CheckboxContainer).call(this, props));

            _this.state = {
                checked: typeof props.checked == "undefined" ? false : props.checked,
                focus: false
            };
            _this.onChange = _this.onChange.bind(_this);
            _this.onFocus = _this.onFocus.bind(_this);
            _this.onBlur = _this.onBlur.bind(_this);
            _this.onMouseUp = _this.onMouseUp.bind(_this);
            return _this;
        }

        _createClass(CheckboxContainer, [{
            key: 'onChange',
            value: function onChange(e) {
                e.persist();
                var _onChange = this.props.onChange || function (e) {
                    return e;
                };
                this.setState(function (state) {
                    return _extends({}, state, {
                        checked: e.target.checked
                    });
                }, function () {
                    return _onChange(e);
                });
            }
        }, {
            key: 'onFocus',
            value: function onFocus(e) {
                e.persist();
                var _onFocus = this.props.onFocus || function (e) {
                    return e;
                };
                this.setState(function (state) {
                    return _extends({}, state, {
                        focus: true
                    });
                }, function () {
                    return _onFocus(e);
                });
            }
        }, {
            key: 'onBlur',
            value: function onBlur(e, input) {
                e.persist();
                var _onBlur = this.props.onBlur || function (e) {
                    return e;
                };
                this.setState(function (state) {
                    return _extends({}, state, {
                        focus: false
                    });
                }, function () {
                    return _onBlur(e);
                });
                window.setTimeout(function () {
                    return input.blur();
                }, Constant_.TINY_TIMEOUT);
            }
        }, {
            key: 'onMouseUp',
            value: function onMouseUp(e, input) {
                e.persist();
                var _onMouseUp = this.props.onMouseUp || function (e) {
                    return e;
                };
                this.setState(function (state) {
                    return _extends({}, state, {
                        focus: false
                    });
                }, function () {
                    return _onMouseUp(e);
                });
                window.setTimeout(function () {
                    return input.blur();
                }, Constant_.TINY_TIMEOUT);
            }
        }, {
            key: 'componentWillReceiveProps',
            value: function componentWillReceiveProps(newProps) {
                if (this.props.checked != newProps.checked) {
                    this.setState(function (state) {
                        return _extends({}, state, {
                            checked: newProps.checked
                        });
                    });
                }
            }
        }, {
            key: 'render',
            value: function render() {
                var _props = this.props;
                var checked = _props.checked;
                var onChange = _props.onChange;
                var onFocus = _props.onFocus;
                var onBlur = _props.onBlur;
                var onMouseUp = _props.onMouseUp;

                var otherProps = _objectWithoutProperties(_props, ['checked', 'onChange', 'onFocus', 'onBlur', 'onMouseUp']);

                return _react2["default"].createElement(CheckboxComponent, _extends({
                    checked: this.state.checked,
                    onChange: this.onChange,
                    onFocus: this.onFocus,
                    onBlur: this.onBlur,
                    onMouseUp: this.onMouseUp
                }, otherProps));
            }
        }]);

        return CheckboxContainer;
    }(_react2["default"].Component);
};

exports["default"] = enhance(Checkbox);