'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Dialog = exports.DialogActions = exports.DialogContent = exports.DialogTitle = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _dialogPolyfill = require('dialog-polyfill');

var _dialogPolyfill2 = _interopRequireDefault(_dialogPolyfill);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DialogTitle = exports.DialogTitle = function DialogTitle(props) {
    var importance = props.importance;
    var style = props.style;
    var children = props.children;
    var className = props.className;

    var otherProps = _objectWithoutProperties(props, ['importance', 'style', 'children', 'className']);

    return _react2["default"].createElement('h' + importance, _extends({}, otherProps, {
        className: 'mdl-dialog__title'
    }), children);
};

DialogTitle.propTypes = {
    importance: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6])
};

DialogTitle.defaultProps = {
    importance: 2
};

var DialogContent = exports.DialogContent = function DialogContent(props) {

    return _react2["default"].createElement(
        'div',
        { className: 'mdl-dialog__content' },
        props.children
    );
};

var DialogActions = exports.DialogActions = function DialogActions(props) {

    var className = (0, _classnames2["default"])({
        'mdl-dialog__actions': true,
        'mdl-dialog__actions--full-width': props.fullWidth
    });

    return _react2["default"].createElement(
        'div',
        { className: className },
        props.children
    );
};

DialogActions.propTypes = {
    fullWidth: _react2["default"].PropTypes.bool
};

DialogActions.defaultProps = {
    fullWidth: false
};

var Dialog = exports.Dialog = function (_React$Component) {
    _inherits(Dialog, _React$Component);

    function Dialog(props) {
        _classCallCheck(this, Dialog);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Dialog).call(this, props));

        _this.displayName = 'Dialog';
        _this._dialog = null;
        _this._neverOpened = true; /* we do not use state here since it's not relative to rendering */
        return _this;
    }

    _createClass(Dialog, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this._dialog) {
                _dialogPolyfill2["default"].registerDialog(this._dialog);
                this._handleDialog();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this._handleDialog();
        }
    }, {
        key: '_handleDialog',
        value: function _handleDialog() {
            if (this.props.open === true) {
                this._dialog && this._dialog.showModal();
                this._neverOpened = false;
            } else {
                this._dialog && !this._neverOpened && this._dialog.close();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2["default"].createElement(
                'dialog',
                { className: 'mdl-dialog', ref: function ref(dialog) {
                        return _this2._dialog = dialog;
                    } },
                this.props.children
            );
        }
    }]);

    return Dialog;
}(_react2["default"].Component);

Dialog.propTypes = {
    open: _react2["default"].PropTypes.bool
};