'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Cell = exports.Grid = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Grid = exports.Grid = function Grid(props) {
    var noSpacing = props.noSpacing;

    var otherProps = _objectWithoutProperties(props, ['noSpacing']);

    var getClasses = function getClasses() {
        return {
            'mdl-grid': true,
            'mdl-grid--no-spacing': noSpacing
        };
    };

    return _react2["default"].createElement(
        'div',
        _extends({ className: (0, _classnames2["default"])(getClasses()) }, otherProps),
        props.children
    );
};

Grid.propTypes = {
    noSpacing: _react2["default"].PropTypes.bool
};

Grid.defaultProps = {
    noSpacing: false
};

var Cell = exports.Cell = function Cell(props) {
    var col = props.col;
    var desktop = props.desktop;
    var tablet = props.tablet;
    var phone = props.phone;
    var offset = props.offset;
    var offsetDesktop = props.offsetDesktop;
    var offsetTablet = props.offsetTablet;
    var offsetPhone = props.offsetPhone;
    var order = props.order;
    var orderDesktop = props.orderDesktop;
    var orderTablet = props.orderTablet;
    var orderPhone = props.orderPhone;
    var hideDesktop = props.hideDesktop;
    var hideTablet = props.hideTablet;
    var hidePhone = props.hidePhone;
    var stretch = props.stretch;
    var align = props.align;

    var otherProps = _objectWithoutProperties(props, ['col', 'desktop', 'tablet', 'phone', 'offset', 'offsetDesktop', 'offsetTablet', 'offsetPhone', 'order', 'orderDesktop', 'orderTablet', 'orderPhone', 'hideDesktop', 'hideTablet', 'hidePhone', 'stretch', 'align']);

    var getClasses = function getClasses() {
        var _ref;

        return _ref = {
            'mdl-cell': true
        }, _defineProperty(_ref, 'mdl-cell--' + col + '-col', typeof col !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + desktop + '-col-desktop', typeof desktop !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + tablet + '-col-tablet', typeof tablet !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + phone + '-col-phone', typeof phone !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + offset + '-offset', typeof offset !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + offsetDesktop + '-offset-desktop', typeof offsetDesktop !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + offsetTablet + '-offset-tablet', typeof offsetTablet !== 'undefined'), _defineProperty(_ref, 'mdl-cell--' + offsetPhone + '-offset-phone', typeof offsetPhone !== 'undefined'), _defineProperty(_ref, 'mdl-cell--order-' + order, typeof order !== 'undefined'), _defineProperty(_ref, 'mdl-cell--order-' + orderDesktop + '-desktop', typeof orderDesktop !== 'undefined'), _defineProperty(_ref, 'mdl-cell--order-' + orderTablet + '-tablet', typeof orderTablet !== 'undefined'), _defineProperty(_ref, 'mdl-cell--order-' + orderPhone + '-phone', typeof orderPhone !== 'undefined'), _defineProperty(_ref, 'mdl-cell--hide-desktop', typeof hideDesktop !== 'undefined'), _defineProperty(_ref, 'mdl-cell--hide-tablet', typeof hideTablet !== 'undefined'), _defineProperty(_ref, 'mdl-cell--hide-phone', typeof hidePhone !== 'undefined'), _defineProperty(_ref, 'mdl-cell--stretch', stretch), _defineProperty(_ref, 'mdl-cell--top', align === 'top'), _defineProperty(_ref, 'mdl-cell--middle', align === 'middle'), _defineProperty(_ref, 'mdl-cell--bottom', align === 'bottom'), _ref;
    };

    return _react2["default"].createElement(
        'div',
        _extends({ className: (0, _classnames2["default"])(getClasses()) }, otherProps),
        props.children
    );
};

Cell.propTypes = {
    col: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    desktop: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    tablet: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8]),
    phone: _react2["default"].PropTypes.oneOf([1, 2, 3, 4]),
    offset: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]),
    offsetDesktop: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]),
    offsetTablet: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7]),
    offsetPhone: _react2["default"].PropTypes.oneOf([1, 2, 3]),
    order: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12]),
    orderDesktop: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    orderTablet: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    orderPhone: _react2["default"].PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    hideDesktop: _react2["default"].PropTypes.bool,
    hideTablet: _react2["default"].PropTypes.bool,
    hidePhone: _react2["default"].PropTypes.bool,
    stretch: _react2["default"].PropTypes.bool,
    align: _react2["default"].PropTypes.oneOf(['top', 'middle', 'bottom'])
};

Cell.defaultProps = {
    col: 4,
    stretch: true
};