'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.LayoutTabPanel = exports.LayoutTab = exports.LayoutTabBar = exports.Layout = exports.LayoutContent = exports.DrawerButton = exports.Drawer = exports.LayoutNavLink = exports.LayoutNav = exports.LayoutSpacer = exports.LayoutTitle = exports.LayoutHeaderRow = exports.LayoutHeader = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Constant_ = {
    MAX_WIDTH: '(max-width: 1024px)',
    TAB_SCROLL_PIXELS: 100,
    RESIZE_TIMEOUT: 100,

    MENU_ICON: '&#xE5D2;',
    CHEVRON_LEFT: 'chevron_left',
    CHEVRON_RIGHT: 'chevron_right'
};

var Keycodes_ = {
    ENTER: 13,
    ESCAPE: 27,
    SPACE: 32
};

var Mode_ = {
    STANDARD: 0,
    SEAMED: 1,
    WATERFALL: 2,
    SCROLL: 3
};

var CssClasses_ = {
    CONTAINER: 'mdl-layout__container',
    HEADER: 'mdl-layout__header',
    DRAWER: 'mdl-layout__drawer',
    CONTENT: 'mdl-layout__content',
    DRAWER_BTN: 'mdl-layout__drawer-button',

    ICON: 'material-icons',

    JS_RIPPLE_EFFECT: 'mdl-js-ripple-effect',
    RIPPLE_CONTAINER: 'mdl-layout__tab-ripple-container',
    RIPPLE: 'mdl-ripple',
    RIPPLE_IGNORE_EVENTS: 'mdl-js-ripple-effect--ignore-events',

    HEADER_SEAMED: 'mdl-layout__header--seamed',
    HEADER_WATERFALL: 'mdl-layout__header--waterfall',
    HEADER_SCROLL: 'mdl-layout__header--scroll',

    FIXED_HEADER: 'mdl-layout--fixed-header',
    OBFUSCATOR: 'mdl-layout__obfuscator',

    TAB_BAR: 'mdl-layout__tab-bar',
    TAB_CONTAINER: 'mdl-layout__tab-bar-container',
    TAB: 'mdl-layout__tab',
    TAB_BAR_BUTTON: 'mdl-layout__tab-bar-button',
    TAB_BAR_LEFT_BUTTON: 'mdl-layout__tab-bar-left-button',
    TAB_BAR_RIGHT_BUTTON: 'mdl-layout__tab-bar-right-button',
    PANEL: 'mdl-layout__tab-panel',

    HAS_DRAWER: 'has-drawer',
    HAS_TABS: 'has-tabs',
    HAS_SCROLLING_HEADER: 'has-scrolling-header',
    CASTING_SHADOW: 'is-casting-shadow',
    IS_COMPACT: 'is-compact',
    IS_SMALL_SCREEN: 'is-small-screen',
    IS_DRAWER_OPEN: 'is-visible',
    IS_ACTIVE: 'is-active',
    IS_UPGRADED: 'is-upgraded',
    IS_ANIMATING: 'is-animating',

    ON_LARGE_SCREEN: 'mdl-layout--large-screen-only',
    ON_SMALL_SCREEN: 'mdl-layout--small-screen-only'

};

var LayoutHeader = exports.LayoutHeader = function LayoutHeader(props) {
    var title = props.title;
    var children = props.children;
    var scroll = props.scroll;
    var waterfall = props.waterfall;
    var waterfallHideTop = props.waterfallHideTop;
    var transparent = props.transparent;
    var seamed = props.seamed;

    var otherProps = _objectWithoutProperties(props, ['title', 'children', 'scroll', 'waterfall', 'waterfallHideTop', 'transparent', 'seamed']);

    var getClasses = function getClasses() {
        return _defineProperty({
            'mdl-layout__header': true,
            'mdl-layout__header--scroll': scroll,
            'mdl-layout__header--waterfall': waterfall,
            'mdl-layout__header--waterfall-hide-top': waterfallHideTop,
            'mdl-layout__header--transparent': transparent,
            'mdl-layout__header--seamed': seamed
        }, CssClasses_.CASTING_SHADOW, !seamed);
    };

    return _react2["default"].createElement(
        'header',
        _extends({ className: (0, _classnames2["default"])(getClasses()) }, otherProps),
        props.children
    );
};

LayoutHeader.propTypes = {
    children: _react2["default"].PropTypes.node.isRequired,
    scroll: _react2["default"].PropTypes.bool,
    waterfall: _react2["default"].PropTypes.bool,
    waterfallHideTop: _react2["default"].PropTypes.bool,
    transparent: _react2["default"].PropTypes.bool,
    seamed: _react2["default"].PropTypes.bool
};

var LayoutHeaderRow = exports.LayoutHeaderRow = function LayoutHeaderRow(props) {
    var children = props.children;

    var otherProps = _objectWithoutProperties(props, ['children']);

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-layout__header-row' }, otherProps),
        children
    );
};

var LayoutTitle = exports.LayoutTitle = function LayoutTitle(props) {
    var children = props.children;

    var otherProps = _objectWithoutProperties(props, ['children']);

    return _react2["default"].createElement(
        'span',
        _extends({ className: 'mdl-layout-title' }, otherProps),
        children
    );
};

var LayoutSpacer = exports.LayoutSpacer = function LayoutSpacer() {
    return _react2["default"].createElement('div', { className: 'mdl-layout-spacer' });
};

var LayoutNav = exports.LayoutNav = function LayoutNav(props) {
    var children = props.children;

    var otherProps = _objectWithoutProperties(props, ['children']);

    return _react2["default"].createElement(
        'nav',
        _extends({ className: 'mdl-navigation' }, otherProps),
        children
    );
};

var LayoutNavLink = exports.LayoutNavLink = function LayoutNavLink(props) {
    var children = props.children;

    var otherProps = _objectWithoutProperties(props, ['children']);

    return _react2["default"].createElement(
        'a',
        _extends({ className: 'mdl-navigation__link' }, otherProps),
        children
    );
};

var Drawer = exports.Drawer = function Drawer(props) {
    var children = props.children;
    var className = props.className;

    var otherProps = _objectWithoutProperties(props, ['children', 'className']);

    return _react2["default"].createElement(
        'div',
        _extends({ className: className + ' mdl-layout__drawer' }, otherProps),
        children
    );
};

var DrawerButton = exports.DrawerButton = function DrawerButton(props) {
    return _react2["default"].createElement(
        'div',
        _extends({
            'aria-expanded': false,
            role: 'button',
            tabindex: 0,
            className: CssClasses_.DRAWER_BTN
        }, props),
        _react2["default"].createElement(
            'i',
            { className: CssClasses_.ICON },
            'menu'
        )
    );
};

var LayoutObsfuscator = function LayoutObsfuscator(props) {
    var _classNames;

    return _react2["default"].createElement('div', _extends({ className: (0, _classnames2["default"])((_classNames = {}, _defineProperty(_classNames, CssClasses_.IS_DRAWER_OPEN, true), _defineProperty(_classNames, CssClasses_.OBFUSCATOR, true), _classNames)) }, props));
};

var LayoutContent = exports.LayoutContent = function LayoutContent(props) {
    var children = props.children;

    var otherProps = _objectWithoutProperties(props, ['children']);

    return _react2["default"].createElement(
        'main',
        _extends({ className: 'mdl-layout__content' }, otherProps),
        children
    );
};

var Layout = exports.Layout = function (_React$Component) {
    _inherits(Layout, _React$Component);

    function Layout(props) {
        _classCallCheck(this, Layout);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Layout).call(this, props));

        _this.displayName = 'Layout';
        _this.container_ = null;
        _this.element_ = null;
        _this.focusedElement = null;
        _this.headerComponent_ = null;
        _this.drawerComponent_ = null;
        _this.contentComponent_ = null;
        _this.mode = Mode_.STANDARD;
        _this.classes = _defineProperty({
            'mdl-layout': true,
            'mdl-layout--fixed-header': props.fixedHeader,
            'mdl-layout--fixed-tabs': props.fixedTabs
        }, CssClasses_.IS_UPGRADED, true), _this.layoutContainerClasses = {};
        _this.headerClasses = {};
        _this.tabBarClasses = {};
        _this.state = {
            drawerOpened: props.fixedDrawer,
            hasObfuscator: !props.fixedDrawer
        };
        return _this;
    }

    _createClass(Layout, [{
        key: '_setChildrenDOMNodes',
        value: function _setChildrenDOMNodes() {
            var _this2 = this;

            _react2["default"].Children.map(this.props.children, function (child) {
                switch (child.type) {
                    case LayoutHeader:
                        _this2.headerComponent_ = child;
                        _react2["default"].Children.map(child.props.children, function (headerChild) {
                            if (headerChild.type == LayoutTabBar) {
                                _this2.tabBarComponent_ = headerChild;
                                _this2.setState(function (state) {
                                    return _extends({}, state, {
                                        classes: _extends({}, state.classes, _defineProperty({}, CssClasses_.HAS_TABS, true))
                                    });
                                });
                            }
                        });
                        break;
                    case Drawer:
                        _this2.drawerComponent_ = child;
                        _this2.setState(function (state) {
                            return _extends({}, state, {
                                classes: _extends({}, state.classes, _defineProperty({}, CssClasses_.HAS_DRAWER, true))
                            });
                        });
                        break;
                    case LayoutContent:
                        _this2.contentComponent_ = child;
                        break;
                }
            });
        }
    }, {
        key: '_initHeader',
        value: function _initHeader() {
            if (this.headerComponent_) {
                this._setMode();
                if (this.mode === Mode_.STANDARD) {
                    this.headerClasses = _extends({}, this.headerClasses, _defineProperty({}, CssClasses_.CASTING_SHADOW, true));
                    if (this.tabBarComponent_) {
                        this.tabBarClasses = _extends({}, this.tabBarClasses, _defineProperty({}, CssClasses_.CASTING_SHADOW, true));
                    }
                } else if (this.mode === Mode_.WATERFALL) {
                    //TODO handle scroll
                }
            }
        }
    }, {
        key: '_setMode',
        value: function _setMode() {
            if (this.headerComponent_.props.waterfall) {
                this.mode = Mode_.WATERFALL;
            } else if (this.headerComponent_.props.scroll) {
                this.mode = Mode_.SCROLL;
                this.layoutContainerClasses = _extends({}, this.layoutContainerClasses, _defineProperty({}, CssClasses_.HAS_SCROLLING_HEADER, true));
            }
        }
    }, {
        key: '_drawerToggleHandler',
        value: function _drawerToggleHandler(evt) {
            if (this.props.fixedDrawer) {
                return;
            }

            if (evt && evt.type === 'keydown') {
                if (evt.keyCode === this.Keycodes_.SPACE || evt.keyCode === this.Keycodes_.ENTER) {
                    // prevent scrolling in drawer nav
                    evt.preventDefault();
                } else {
                    // prevent other keys
                    return;
                }
            }

            this.setState(function (state) {
                return _extends({}, state, {
                    drawerOpened: !state.drawerOpened
                });
            });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.element_) {
                var focusedElement = this.element_.querySelector(':focus');
                if (focusedElement) {
                    focusedElement.focus();
                }
            }
            this._setChildrenDOMNodes();
            this._initHeader();
        }
    }, {
        key: 'render',
        value: function render() {

            var layoutContainerProps = _extends({}, this.props, {
                className: this.props.className + ' ' + (0, _classnames2["default"])(this.layoutContainerClasses)
            });

            var self = this;

            return _react2["default"].createElement(
                LayoutContainer,
                _extends({ ref: function ref(_ref3) {
                        return self.container_ = _reactDom2["default"].findDOMNode(_ref3);
                    } }, layoutContainerProps),
                _react2["default"].createElement(
                    'div',
                    { className: (0, _classnames2["default"])(self.classes), ref: function ref(_ref2) {
                            return self.element_ = _ref2;
                        } },
                    _react2["default"].Children.map(self.props.children, function (child) {
                        switch (child.type) {
                            case Drawer:
                                return _react2["default"].createElement(
                                    'div',
                                    null,
                                    self.state.drawerOpened ? _react2["default"].cloneElement(child, _extends({}, child.props, {
                                        className: child.props.className + ' ' + CssClasses_.IS_DRAWER_OPEN
                                    })) : child,
                                    !self.state.hasFixedHeader && _react2["default"].createElement(
                                        DrawerButton,
                                        {
                                            onClick: function onClick(e) {
                                                return self._drawerToggleHandler(e);
                                            },
                                            onKeyDown: function onKeyDown(e) {
                                                return self._drawerToggleHandler(e);
                                            },
                                            style: { color: 'white' } },
                                        _react2["default"].createElement(
                                            'i',
                                            { className: 'material-icons' },
                                            'menu'
                                        )
                                    )
                                );
                            case LayoutContent:
                                return self.state.drawerOpened && self.state.hasObfuscator ? _react2["default"].createElement(
                                    'div',
                                    null,
                                    child,
                                    _react2["default"].createElement(LayoutObsfuscator, {
                                        onClick: function onClick(e) {
                                            return self._drawerToggleHandler(e);
                                        },
                                        onKeyDown: function onKeyDown(e) {
                                            return self._drawerToggleHandler(e);
                                        } })
                                ) : child;
                            case LayoutHeader:
                                return self.props.fixedHeader ? !self.state.drawerOpened ? _react2["default"].cloneElement(child, child.props, [_react2["default"].createElement(
                                    DrawerButton,
                                    {
                                        key: 'drawer',
                                        onClick: function onClick(e) {
                                            return self._drawerToggleHandler(e);
                                        },
                                        onKeyDown: function onKeyDown(e) {
                                            return self._drawerToggleHandler(e);
                                        },
                                        style: { color: 'white' } },
                                    _react2["default"].createElement(
                                        'i',
                                        { className: 'material-icons' },
                                        'menu'
                                    )
                                )].concat(_toConsumableArray(_react2["default"].Children.toArray(child.props.children)))) : child : child;
                            default:
                                return child;
                        }
                    })
                )
            );
        }
    }]);

    return Layout;
}(_react2["default"].Component);

Layout.propTypes = {
    fixedDrawer: _react2["default"].PropTypes.bool,
    fixedHeader: _react2["default"].PropTypes.bool,
    fixedTabs: _react2["default"].PropTypes.bool
};

Layout.defaultProps = {
    fixedDrawer: false,
    fixedHeader: false,
    fixedTabs: false
};

var LayoutContainer = function (_React$Component2) {
    _inherits(LayoutContainer, _React$Component2);

    function LayoutContainer(props) {
        _classCallCheck(this, LayoutContainer);

        var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(LayoutContainer).call(this, props));

        _this3.displayName = 'LayoutContainer';
        _this3.element_ = null;
        return _this3;
    }

    _createClass(LayoutContainer, [{
        key: 'render',
        value: function render() {
            var _this4 = this;

            var className = CssClasses_.CONTAINER + ' ' + (0, _classnames2["default"])(this.layoutContainerClasses);

            return _react2["default"].createElement(
                'div',
                _extends({ className: className, ref: function ref(_ref4) {
                        return _this4.element_ = _ref4;
                    } }, this.props),
                this.props.children
            );
        }
    }]);

    return LayoutContainer;
}(_react2["default"].Component);

var LayoutTabBar = exports.LayoutTabBar = function (_React$Component3) {
    _inherits(LayoutTabBar, _React$Component3);

    function LayoutTabBar(props) {
        _classCallCheck(this, LayoutTabBar);

        var _this5 = _possibleConstructorReturn(this, Object.getPrototypeOf(LayoutTabBar).call(this, props));

        _this5.displayName = 'LayoutTabBar';
        _this5.tabBar_ = null;
        return _this5;
    }

    _createClass(LayoutTabBar, [{
        key: '_scrollTabBar',
        value: function _scrollTabBar(direction) {
            if (this.tabBar_) {
                this.tabBar_.scrollLeft += direction * Constant_.TAB_SCROLL_PIXELS;
                this.forceUpdate();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this6 = this;

            var _props = this.props;
            var className = _props.className;
            var children = _props.children;

            var otherProps = _objectWithoutProperties(_props, ['className', 'children']);

            return _react2["default"].createElement(
                'div',
                { className: CssClasses_.TAB_CONTAINER },
                _react2["default"].createElement(LayoutTabBarButton, { onClick: function onClick() {
                        return _this6._scrollTabBar(-1);
                    }, left: true, active: this.tabBar_ && this.tabBar_.scrollLeft > 0 }),
                _react2["default"].createElement(
                    'div',
                    { className: className + ' ' + CssClasses_.TAB_BAR, ref: function ref(_ref5) {
                            return _this6.tabBar_ = _ref5;
                        } },
                    children
                ),
                _react2["default"].createElement(LayoutTabBarButton, { onClick: function onClick() {
                        return _this6._scrollTabBar(1);
                    }, right: true, active: this.tabBar_ && this.tabBar_.scrollLeft < this.tabBar_.scrollWidth - this.tabBar_.offsetWidth })
            );
        }
    }]);

    return LayoutTabBar;
}(_react2["default"].Component);

var LayoutTabBarButton = function LayoutTabBarButton(props) {
    var _classes;

    var right = props.right;
    var left = props.left;
    var active = props.active;

    var otherProps = _objectWithoutProperties(props, ['right', 'left', 'active']);

    var classes = (_classes = {}, _defineProperty(_classes, CssClasses_.TAB_BAR_BUTTON, true), _defineProperty(_classes, CssClasses_.IS_ACTIVE, active), _defineProperty(_classes, CssClasses_.TAB_BAR_LEFT_BUTTON, left), _defineProperty(_classes, CssClasses_.TAB_BAR_RIGHT_BUTTON, right), _classes);

    return _react2["default"].createElement(
        'div',
        _extends({ className: (0, _classnames2["default"])(classes) }, otherProps),
        _react2["default"].createElement(
            'i',
            { className: CssClasses_.ICON },
            left && Constant_.CHEVRON_LEFT || right && Constant_.CHEVRON_RIGHT
        )
    );
};

LayoutTabBarButton.propTypes = {
    active: _react2["default"].PropTypes.bool,
    left: _react2["default"].PropTypes.bool,
    right: _react2["default"].PropTypes.bool
};

var LayoutTab = exports.LayoutTab = function LayoutTab(props) {
    var _classes2;

    var className = props.className;
    var active = props.active;
    var href = props.href;

    var otherProps = _objectWithoutProperties(props, ['className', 'active', 'href']);

    var classes = (_classes2 = {}, _defineProperty(_classes2, CssClasses_.TAB, true), _defineProperty(_classes2, CssClasses_.IS_ACTIVE, props.active), _classes2);

    return _react2["default"].createElement(
        'a',
        _extends({ className: className + ' ' + (0, _classnames2["default"])(classes), href: href }, otherProps),
        props.children
    );
};

LayoutTab.propTypes = {
    active: _react2["default"].PropTypes.bool
};

LayoutTab.defaultProps = {
    active: false
};

var LayoutTabPanel = exports.LayoutTabPanel = function LayoutTabPanel(props) {
    var _classes3;

    var className = props.className;
    var id = props.id;

    var otherProps = _objectWithoutProperties(props, ['className', 'id']);

    var classes = (_classes3 = {}, _defineProperty(_classes3, CssClasses_.PANEL, true), _defineProperty(_classes3, CssClasses_.IS_ACTIVE, props.active), _classes3);

    return _react2["default"].createElement(
        'section',
        _extends({ className: className + ' ' + (0, _classnames2["default"])(classes), id: id }, otherProps),
        _react2["default"].createElement(
            'div',
            { className: 'page-content' },
            props.children
        )
    );
};

LayoutTabPanel.propTypes = {
    active: _react2["default"].PropTypes.bool
};

LayoutTabPanel.defaultProps = {
    active: false
};