'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SubDiv = exports.ListItem = exports.List = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var List = exports.List = function List(_ref) {
    var children = _ref.children;

    var otherProps = _objectWithoutProperties(_ref, ['children']);

    return _react2["default"].createElement(
        'ul',
        _extends({ className: 'mdl-list' }, otherProps),
        children
    );
};

var ListItem = exports.ListItem = function ListItem(_ref2) {
    var children = _ref2.children;
    var nLine = _ref2.nLine;

    var otherProps = _objectWithoutProperties(_ref2, ['children', 'nLine']);

    var classes = {
        'mdl-list__item': true,
        'mdl-list__item--two-line': nLine == 2,
        'mdl-list__item--three-line': nLine === 3
    };

    return _react2["default"].createElement(
        'li',
        _extends({ className: (0, _classnames2["default"])(classes) }, otherProps),
        children
    );
};

ListItem.propTypes = {
    nLine: _react2["default"].PropTypes.oneOf([2, 3])
};

var SubDiv = exports.SubDiv = function SubDiv(_ref3) {
    var children = _ref3.children;
    var type = _ref3.type;

    var otherProps = _objectWithoutProperties(_ref3, ['children', 'type']);

    var classes = {
        'mdl-list__item-primary-content': type === 'primary',
        'mdl-list__item-secondary-content': type === 'secondary',
        'mdl-list__item-avatar': type === 'avatar',
        'mdl-list__item-icon': type === 'icon',
        'material-icons': type === 'icon' || type === 'avatar',
        'mdl-list__item-secondary-info': type === 'info',
        'mdl-list__item-secondary-action': type === 'action',
        'mdl-list__item-text-body': type === 'textBody',
        'mdl-list__item-sub-title': type === 'subTitle'
    };

    var element = type === 'action' ? 'a' : 'span';
    if (type === 'avatar' || type === 'icon') {
        element = 'i';
    }
    return _react2["default"].createElement(element, _extends({}, otherProps, {
        className: (0, _classnames2["default"])(classes)
    }), children);
};

SubDiv.propTypes = {
    type: _react2["default"].PropTypes.oneOf(['primary', 'secondary', 'avatar', 'icon', 'info', 'action', 'subTitle', 'textBody'])
};