'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _cssClasses;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCreateFragment = require('react-addons-create-fragment');

var _reactAddonsCreateFragment2 = _interopRequireDefault(_reactAddonsCreateFragment);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var INITIAL_SCALE = 'scale(0.0001, 0.0001)';
var INITIAL_SIZE = '1px';
var INITIAL_OPACITY = '0.4';
var FINAL_OPACITIY = '0';
var FINAL_SCALE = '';

var cssClasses = (_cssClasses = {
    RIPPLE_CONTAINER: 'mdl-button__ripple-container',
    RIPPLE: 'mdl-ripple',
    RIPPLE_CENTER: 'mdl-ripple--center',
    RIPPLE_EFFECT_IGNORE_EVENTS: 'mdl-js-ripple-effect--ignore-events'
}, _defineProperty(_cssClasses, 'RIPPLE', 'mdl-ripple'), _defineProperty(_cssClasses, 'IS_ANIMATING', 'is-animating'), _defineProperty(_cssClasses, 'IS_VISIBLE', 'is-visible'), _cssClasses);

var RippleContainer = function (_React$Component) {
    _inherits(RippleContainer, _React$Component);

    function RippleContainer(props) {
        _classCallCheck(this, RippleContainer);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RippleContainer).call(this, props));

        _this.displayName = 'RippleContainer';
        _this.shouldComponentUpdate = _reactAddonsPureRenderMixin2["default"].shouldComponentUpdate.bind(_this);
        return _this;
    }

    _createClass(RippleContainer, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var rippleClassNames = _extends(_defineProperty({}, cssClasses.RIPPLE, true), this.props.rippleClassNames);

            return _react2["default"].createElement(
                'span',
                { className: cssClasses.RIPPLE_CONTAINER },
                _react2["default"].createElement('span', {
                    className: (0, _classnames2["default"])(rippleClassNames),
                    style: this.props.rippleStyle,
                    ref: function ref(_ref) {
                        return _this2.props.setRippleElement(_ref);
                    } })
            );
        }
    }]);

    return RippleContainer;
}(_react2["default"].Component);

RippleContainer.propTypes = {
    setRippleElement: _react2["default"].PropTypes.func.isRequired,
    rippleClassNames: _react2["default"].PropTypes.object.isRequired,
    rippleStyle: _react2["default"].PropTypes.object.isRequired
};

var RippleEffect = function (_React$Component2) {
    _inherits(RippleEffect, _React$Component2);

    function RippleEffect(props) {
        _classCallCheck(this, RippleEffect);

        var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(RippleEffect).call(this, props));

        _this3.displayName = 'RippleEffect';
        _this3.element_ = null;
        _this3.rippleElement_ = null;
        _this3.state = {
            frameCount: 0,
            ignoringMouseDown: false,
            x: 0,
            y: 0,
            boundHeight: 0,
            boundWidth: 0,
            rippleElementStyle: {},
            rippleClasses: {}
        };
        _this3.shouldComponentUpdate = _reactAddonsPureRenderMixin2["default"].shouldComponentUpdate.bind(_this3);
        return _this3;
    }

    _createClass(RippleEffect, [{
        key: 'downHandler',
        value: function downHandler(event) {
            var _this4 = this;

            var state = _extends({}, this.state);

            if (!state.rippleElementStyle.width && !state.rippleElementStyle.height) {
                var rect = this.element_.getBoundingClientRect();
                var rippleSize = Math.sqrt(rect.width * rect.width + rect.height * rect.height) * 2 + 2;
                state = _extends({}, state, {
                    boundHeight: rect.height,
                    boundWidth: rect.width,
                    rippleElementStyle: _extends({}, state.rippleElementStyle, {
                        width: rippleSize + 'px',
                        height: rippleSize + 'px'
                    })
                });
            }

            state.rippleClasses = _extends({}, state.rippleClasses, _defineProperty({}, cssClasses.IS_VISIBLE, true));

            if (event.type === 'mousedown' && state.ignoringMouseDown) {
                state.ignoringMouseDown = false;
            } else {
                if (event.type === 'touchstart') {
                    state.ignoringMouseDown = true;
                }
                if (state.frameCount > 0) {
                    return;
                }
                state.frameCount = 1;
                var bound = event.currentTarget.getBoundingClientRect();
                var x = void 0,
                    y = void 0;
                // Check if we are handling a keyboard click.
                if (event.clientX === 0 && event.clientY === 0) {
                    x = Math.round(bound.width / 2);
                    y = Math.round(bound.height / 2);
                } else {
                    var clientX = event.clientX ? event.clientX : event.touches[0].clientX;
                    var clientY = event.clientY ? event.clientY : event.touches[0].clientY;
                    x = Math.round(clientX - bound.left);
                    y = Math.round(clientY - bound.top);
                }
                state.x = x, state.y = y;
                state = this.setRippleStyles(state, true);
                this.setState(state, function () {
                    return requestAnimationFrame(_this4.animFrameHandler.bind(_this4));
                });
            }
        }
    }, {
        key: 'upHandler',
        value: function upHandler(event) {
            // Don't fire for the artificial "mouseup" generated by a double-click.
            if (event && event.detail !== 2) {
                this.setState(function (state, props) {
                    var _state$rippleClasses = state.rippleClasses;
                    var isVisible = _state$rippleClasses[cssClasses.IS_VISIBLE];

                    var rippleClasses = _objectWithoutProperties(_state$rippleClasses, [cssClasses.IS_VISIBLE]);

                    return { rippleClasses: rippleClasses };
                });
            }
            this.element_.blur();
        }
    }, {
        key: 'animFrameHandler',
        value: function animFrameHandler() {
            var _this5 = this;

            if (this.state.frameCount > 0) {
                this.setState(function (state, props) {
                    return {
                        frameCount: state.frameCount - 1
                    };
                }, function () {
                    return requestAnimationFrame(_this5.animFrameHandler.bind(_this5));
                });
            } else {
                this.setState(function (state, props) {
                    return _this5.setRippleStyles(_extends({}, state), false);
                });
            }
        }
    }, {
        key: 'setRippleStyles',
        value: function setRippleStyles(state, start) {
            var recentering = this.element_.classList.contains(cssClasses.RIPPLE_CENTER);
            if (this.rippleElement_ !== null) {
                var transformString = void 0,
                    scale = void 0;
                var _state$rippleClasses2 = state.rippleClasses;
                var isAnimating = _state$rippleClasses2[cssClasses.IS_ANIMATING];

                var rippleClasses = _objectWithoutProperties(_state$rippleClasses2, [cssClasses.IS_ANIMATING]);

                rippleClasses = start ? rippleClasses : _extends({}, state.rippleClasses, _defineProperty({}, cssClasses.IS_ANIMATING, true));
                var offset = 'translate(' + state.x + 'px,' + state.y + 'px)';

                if (start) {
                    scale = INITIAL_SCALE;
                } else {
                    scale = FINAL_SCALE;
                    if (recentering) {
                        offset = 'translate(' + state.boundWidth / 2 + 'px, ' + state.boundHeight / 2 + 'px)';
                    }
                }

                transformString = 'translate(-50%, -50%) ' + offset + ' ' + scale;

                return _extends({}, state, {
                    rippleElementStyle: _extends({}, state.rippleElementStyle, {
                        WebkitTransform: transformString,
                        MsTransform: transformString,
                        transform: transformString
                    }),
                    rippleClasses: rippleClasses
                });
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.element_ && !this.element_.classList.contains(cssClasses.RIPPLE_EFFECT_IGNORE_EVENTS)) {
                this.element_.addEventListener('mousedown', this.downHandler.bind(this));
                this.element_.addEventListener('touchstart', this.downHandler.bind(this));
                this.element_.addEventListener('mouseup', this.upHandler.bind(this));
                this.element_.addEventListener('mouseleave', this.upHandler.bind(this));
                this.element_.addEventListener('touchend', this.upHandler.bind(this));
                this.element_.addEventListener('blur', this.upHandler.bind(this));
            }
        }
    }, {
        key: 'wrappedChildren',
        value: function wrappedChildren() {
            var _this6 = this;

            var childrensChildFragment = (0, _reactAddonsCreateFragment2["default"])({
                children: this.props.children.props.children,
                rippleContainer: _react2["default"].createElement(RippleContainer, {
                    rippleClassNames: this.state.rippleClasses,
                    rippleStyle: this.state.rippleElementStyle,
                    setRippleElement: function setRippleElement(ref) {
                        return _this6.rippleElement_ = ref;
                    } })
            });

            return _react2["default"].cloneElement(this.props.children, _extends({}, this.props.children.props, {
                children: childrensChildFragment
            }));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this7 = this;

            return _react2["default"].createElement(
                'span',
                { ref: function ref(_ref2) {
                        return _this7.element_ = _ref2 && _ref2.firstChild;
                    } },
                this.wrappedChildren()
            );
        }
    }]);

    return RippleEffect;
}(_react2["default"].Component);

RippleEffect.propTypes = {
    children: _react2["default"].PropTypes.element.isRequired
};

exports["default"] = RippleEffect;