'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Constant_ = {
    MDL_SPINNER_LAYER_COUNT: 4
};

var CssClasses_ = {
    MDL_SPINNER_LAYER: 'mdl-spinner__layer',
    MDL_SPINNER_CIRCLE_CLIPPER: 'mdl-spinner__circle-clipper',
    MDL_SPINNER_CIRCLE: 'mdl-spinner__circle',
    MDL_SPINNER_GAP_PATCH: 'mdl-spinner__gap-patch',
    MDL_SPINNER_LEFT: 'mdl-spinner__left',
    MDL_SPINNER_RIGHT: 'mdl-spinner__right'
};

var Layer = function Layer(_ref) {
    var _classes, _leftClipperClasses, _rightClipperClasses;

    var index = _ref.index;


    var classes = (_classes = {}, _defineProperty(_classes, CssClasses_.MDL_SPINNER_LAYER, true), _defineProperty(_classes, CssClasses_.MDL_SPINNER_LAYER + '-' + index, true), _classes);

    var leftClipperClasses = (_leftClipperClasses = {}, _defineProperty(_leftClipperClasses, CssClasses_.MDL_SPINNER_CIRCLE_CLIPPER, true), _defineProperty(_leftClipperClasses, CssClasses_.MDL_SPINNER_LEFT, true), _leftClipperClasses);

    var rightClipperClasses = (_rightClipperClasses = {}, _defineProperty(_rightClipperClasses, CssClasses_.MDL_SPINNER_CIRCLE_CLIPPER, true), _defineProperty(_rightClipperClasses, CssClasses_.MDL_SPINNER_RIGHT, true), _rightClipperClasses);

    var SpinnerCircle = function SpinnerCircle() {
        return _react2["default"].createElement('div', { className: CssClasses_.MDL_SPINNER_CIRCLE });
    };

    return _react2["default"].createElement(
        'div',
        { className: (0, _classnames2["default"])(classes) },
        _react2["default"].createElement(
            'div',
            { className: (0, _classnames2["default"])(leftClipperClasses) },
            _react2["default"].createElement(SpinnerCircle, null)
        ),
        _react2["default"].createElement(
            'div',
            { className: CssClasses_.MDL_SPINNER_GAP_PATCH },
            _react2["default"].createElement(SpinnerCircle, null)
        ),
        _react2["default"].createElement(
            'div',
            { className: (0, _classnames2["default"])(rightClipperClasses) },
            _react2["default"].createElement(SpinnerCircle, null)
        )
    );
};

var Spinner = function Spinner(_ref2) {
    var className = _ref2.className;
    var active = _ref2.active;
    var singleColor = _ref2.singleColor;

    var otherProps = _objectWithoutProperties(_ref2, ['className', 'active', 'singleColor']);

    var classes = {
        'mdl-spinner': true,
        'is-active': active,
        'is-upgraded': true,
        'mdl-spinner--single-color': singleColor
    };

    return _react2["default"].createElement(
        'div',
        _extends({ className: (0, _classnames2["default"])(classes, className) }, otherProps),
        Array(Constant_.MDL_SPINNER_LAYER_COUNT).fill(0).map(function (l, i) {
            return _react2["default"].createElement(Layer, { key: i, index: i + 1 });
        })
    );
};

exports["default"] = Spinner;