'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MDLtd = exports.MDLth = exports.MDLtr = exports.MDLtbody = exports.MDLthead = exports.MDLtable = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var MDLtable = exports.MDLtable = function MDLtable(_ref) {
    var className = _ref.className;
    var children = _ref.children;

    var otherProps = _objectWithoutProperties(_ref, ['className', 'children']);

    var tableClassName = (0, _classnames2["default"])({
        'mdl-data-table': true,
        'mdl-js-data-table': true
    }, className);

    return _react2["default"].createElement(
        'table',
        _extends({ className: tableClassName }, otherProps),
        children
    );
};

var MDLthead = exports.MDLthead = function MDLthead(_ref2) {
    var children = _ref2.children;

    var otherProps = _objectWithoutProperties(_ref2, ['children']);

    return _react2["default"].createElement(
        'thead',
        otherProps,
        children
    );
};

var MDLtbody = exports.MDLtbody = function MDLtbody(_ref3) {
    var children = _ref3.children;

    var otherProps = _objectWithoutProperties(_ref3, ['children']);

    return _react2["default"].createElement(
        'tbody',
        otherProps,
        children
    );
};

var MDLtr = exports.MDLtr = function MDLtr(_ref4) {
    var children = _ref4.children;
    var selected = _ref4.selected;

    var otherProps = _objectWithoutProperties(_ref4, ['children', 'selected']);

    return _react2["default"].createElement(
        'tr',
        _extends({
            className: (0, _classnames2["default"])({
                'is-selected': selected
            })
        }, otherProps),
        children
    );
};

var MDLth = exports.MDLth = function MDLth(_ref5) {
    var children = _ref5.children;
    var nonNumeric = _ref5.nonNumeric;
    var className = _ref5.className;

    var otherProps = _objectWithoutProperties(_ref5, ['children', 'nonNumeric', 'className']);

    return _react2["default"].createElement(
        'th',
        _extends({ className: (0, _classnames2["default"])({
                'mdl-data-table__cell--non-numeric': nonNumeric
            }, className)
        }, otherProps),
        children
    );
};

var MDLtd = exports.MDLtd = function MDLtd(_ref6) {
    var children = _ref6.children;
    var nonNumeric = _ref6.nonNumeric;
    var className = _ref6.className;

    var otherProps = _objectWithoutProperties(_ref6, ['children', 'nonNumeric', 'className']);

    return _react2["default"].createElement(
        'td',
        _extends({
            className: (0, _classnames2["default"])({
                'mdl-data-table__cell--non-numeric': nonNumeric
            }, className)
        }, otherProps),
        children
    );
};