'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TabPanel = exports.TabLink = exports.TabBar = exports.Tabs = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Ripple = require('./Ripple');

var _Ripple2 = _interopRequireDefault(_Ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = exports.Tabs = function (_React$Component) {
    _inherits(Tabs, _React$Component);

    function Tabs(props) {
        var _this;

        _classCallCheck(this, Tabs);

        (_this = _possibleConstructorReturn(this, Object.getPrototypeOf(Tabs).call(this, props)), _this), _this.state = {
            activeTabId: props.defaultActive
        };
        return _this;
    }

    _createClass(Tabs, [{
        key: 'tabClickHandlerFactory',
        value: function tabClickHandlerFactory(id) {
            var _this2 = this;

            return function (e) {
                e.preventDefault();
                _this2.setState({
                    activeTabId: id
                });
            };
        }
    }, {
        key: 'getPanelIdFromLink',
        value: function getPanelIdFromLink(href) {
            return href.split('#')[1];
        }
    }, {
        key: 'render',
        value: function render() {
            var self = this;

            return _react2["default"].createElement(
                'div',
                _extends({ className: 'mdl-tabs is-upgraded' }, self.props),
                _react2["default"].Children.map(self.props.children, function (child, index) {
                    if (child.type == TabBar) {
                        return _react2["default"].cloneElement(child, {}, _react2["default"].Children.map(child.props.children, function (link) {
                            var id = self.getPanelIdFromLink(link.props.href);
                            return self.props.ripple ? _react2["default"].createElement(
                                _Ripple2["default"],
                                null,
                                _react2["default"].cloneElement(link, {
                                    onClick: self.tabClickHandlerFactory(id),
                                    active: self.state.activeTabId === id
                                })
                            ) : _react2["default"].cloneElement(link, {
                                onClick: self.tabClickHandlerFactory(id),
                                active: self.state.activeTabId === id
                            });
                        }));
                    }
                    if (child.type == TabPanel) {
                        var id = child.props.id;

                        var active = self.state.activeTabId === id;
                        return active && _react2["default"].cloneElement(child, { active: true });
                    }
                })
            );
        }
    }]);

    return Tabs;
}(_react2["default"].Component);

Tabs.propTypes = {
    defaultActive: _react2["default"].PropTypes.string.isRequired,
    ripple: _react2["default"].PropTypes.bool
};

Tabs.defaultProps = {
    ripple: true
};

var TabBar = exports.TabBar = function TabBar(props) {
    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-tabs__tab-bar' }, props),
        props.children
    );
};

var TabLink = exports.TabLink = function TabLink(_ref) {
    var active = _ref.active;

    var props = _objectWithoutProperties(_ref, ['active']);

    return _react2["default"].createElement(
        'a',
        _extends({ className: 'mdl-tabs__tab' + (active ? ' is-active' : '') }, props),
        props.children
    );
};

var TabPanel = exports.TabPanel = function TabPanel(_ref2) {
    var active = _ref2.active;

    var props = _objectWithoutProperties(_ref2, ['active']);

    return _react2["default"].createElement(
        'div',
        _extends({ className: 'mdl-tabs__panel' + (active ? ' is-active' : '') }, props),
        props.children
    );
};