'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CssClasses_ = {
    LABEL: 'mdl-textfield__label',
    INPUT: 'mdl-textfield__input',
    ERROR: 'mdl-textfield__error',
    IS_DIRTY: 'is-dirty',
    IS_FOCUSED: 'is-focused',
    IS_DISABLED: 'is-disabled',
    IS_INVALID: 'is-invalid',
    IS_UPGRADED: 'is-upgraded',
    HAS_PLACEHOLDER: 'has-placeholder',
    HAS_FLOATING_LABEL: 'mdl-textfield--floating-label'
};

var TextField = function (_React$Component) {
    _inherits(TextField, _React$Component);

    function TextField(props) {
        _classCallCheck(this, TextField);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(TextField).call(this, props));

        _this.state = {
            focus: typeof props.autoFocus === "undefined" ? false : props.autoFocus,
            invalid: false,
            value: props.value || ''
        };
        _this.onChange = _this.onChange.bind(_this);
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        _this._input = undefined;
        return _this;
    }

    _createClass(TextField, [{
        key: 'onChange',
        value: function onChange(e) {
            e.persist();
            var currentRowCount = e.target.value.split('\n').length;
            var _onChange = this.props.onChange || function (e) {
                return e;
            };
            if (e.keyCode === 13) {
                if (currentRowCount >= this.props.maxRows) {
                    return;
                }
            }
            this.setState(function (state) {
                return _extends({}, state, {
                    value: event.target.value
                });
            }, function () {
                return _onChange(e);
            });
        }
    }, {
        key: 'onFocus',
        value: function onFocus(e) {
            e.persist();
            var _onFocus = this.props.onFocus || function (e) {
                return e;
            };
            this.setState(function (state) {
                return _extends({}, state, {
                    focus: true
                });
            }, function () {
                return function () {
                    return _onFocus(e);
                };
            });
        }
    }, {
        key: 'onBlur',
        value: function onBlur(e) {
            e.persist();
            var _onBlur = this.props.onBlur || function (e) {
                return e;
            };
            this.setState(function (state) {
                return _extends({}, state, {
                    focus: false
                });
            }, function () {
                return _onBlur(e);
            });
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var _this2 = this;

            if (this.input_.validity) {
                if (!this.input_.validity.valid != this.state.invalid) {
                    this.setState(function (state) {
                        return _extends({}, state, {
                            invalid: !_this2.input_.validity.valid
                        });
                    });
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _cx,
                _this3 = this;

            var _props = this.props;
            var id = _props.id;
            var maxRows = _props.maxRows;
            var className = _props.className;
            var placeholder = _props.placeholder;
            var value = _props.value;
            var disabled = _props.disabled;
            var floatingLabel = _props.floatingLabel;
            var errorText = _props.errorText;
            var autoFocus = _props.autoFocus;
            var onBlur = _props.onBlur;
            var onFocus = _props.onFocus;
            var onChange = _props.onChange;

            var otherProps = _objectWithoutProperties(_props, ['id', 'maxRows', 'className', 'placeholder', 'value', 'disabled', 'floatingLabel', 'errorText', 'autoFocus', 'onBlur', 'onFocus', 'onChange']);

            var divClassName = (0, _classnames2["default"])((_cx = {
                'mdl-textfield': true,
                'mdl-js-textfield': true
            }, _defineProperty(_cx, CssClasses_.IS_UPGRADED, true), _defineProperty(_cx, CssClasses_.IS_DISABLED, disabled), _defineProperty(_cx, CssClasses_.HAS_FLOATING_LABEL, floatingLabel), _defineProperty(_cx, CssClasses_.IS_DIRTY, this.state.value && this.state.value.length > 0), _defineProperty(_cx, CssClasses_.IS_FOCUSED, this.state.focus), _defineProperty(_cx, CssClasses_.IS_INVALID, this.state.invalid), _cx));
            var inputClassName = (0, _classnames2["default"])(_defineProperty({}, CssClasses_.INPUT, true), className);
            var labelClassName = (0, _classnames2["default"])(_defineProperty({}, CssClasses_.LABEL, true));
            var errorClassName = (0, _classnames2["default"])(_defineProperty({}, CssClasses_.ERROR, true));

            return _react2["default"].createElement(
                'div',
                _extends({ className: divClassName }, otherProps),
                _react2["default"].createElement('input', {
                    type: 'text',
                    id: id,
                    ref: function ref(_ref) {
                        return _this3.input_ = _ref;
                    },
                    onBlur: this.onBlur,
                    onFocus: this.onFocus,
                    onChange: this.onChange,
                    value: this.state.value,
                    className: inputClassName,
                    autoFocus: true }),
                _react2["default"].createElement(
                    'label',
                    {
                        htmlFor: id,
                        className: labelClassName },
                    (floatingLabel || this.state.value.length == 0) && placeholder
                ),
                this.state.invalid && this.props.pattern && _react2["default"].createElement(
                    'span',
                    { className: errorClassName },
                    errorText
                )
            );
        }
    }]);

    return TextField;
}(_react2["default"].Component);

exports["default"] = TextField;